﻿using System.Diagnostics;

namespace EntityFrameworkSample
{
    internal class Program
    {
        static void Main(string[] args)
        {
            using (var db = new UserDbContext())
            {
                Console.WriteLine("Select *");
                var userList = db.User.ToList();
                foreach (var user in userList)
                {
                    Console.WriteLine($"[{user.Id}] {user.Name} ({user.Phone}) {user.Address}");
                }

                db.User.Add(new User { Name = "Salmon", Phone = "010-1234-5678", Address = "Wild mountain" });
                db.SaveChanges();

                Console.WriteLine("Select *");
                userList = db.User.ToList();
                foreach (var user in userList)
                {
                    Console.WriteLine($"[{user.Id}] {user.Name} ({user.Phone}) {user.Address}");
                }

                var selected = db.User.Where(u => u.Name == "Torr").FirstOrDefault();
                if (selected != null)
                {
                    selected.Address = "Asgard";
                    db.SaveChanges();
                }

                Console.WriteLine("Select *");
                userList = db.User.ToList();
                foreach (var user in userList)
                {
                    Console.WriteLine($"[{user.Id}] {user.Name} ({user.Phone}) {user.Address}");
                }

                selected = db.User.Where(u => u.Name == "Salmon").FirstOrDefault();
                if (selected != null)
                {
                    db.User.Remove(selected);
                    db.SaveChanges();
                }

                Console.WriteLine("Select *");
                userList = db.User.ToList();
                foreach (var user in userList)
                {
                    Console.WriteLine($"[{user.Id}] {user.Name} ({user.Phone}) {user.Address}");
                }
            }
        }
    }
}